<?php

namespace App\Service;

use App\Entity\Client;
use App\Exception\ClientAlreadyExistsException;
use App\Repository\ClientRepository;

class ClientService
{
    public function __construct(
        public readonly ClientRepository $clientRepository
    ) {
    }

    public function createNewClient(Client $client): Client
    {
        $existing = $this->clientRepository->find($client->getClientId());

        if ($existing !== null) {
            throw new ClientAlreadyExistsException(
                message: sprintf('Client with id "%s" already exists.', $client->getClientId()->toRfc4122())
            );
        }

        return $this->clientRepository->save($client);
    }
}
